      PROGRAM DSENDB ! Bernd Berg Nov 11 2008.
C Send and Receive (S/R) of integer arrays using two MPI processes,
C buffered MPI_BSEND and MPI_RECEIVE with MPI_BUFFER_ATTACH.
C Printout to verify correct S/R.
      implicit real*8 (a-h,o-z)
      implicit logical (l)
      include 'mpif.h'
      PARAMETER(IUO=6,ITWO=2,NDAT=10**6,ONE=1.D00) ! Set dimensions.
      DIMENSION BUFFER(NDAT),SEND(NDAT),RECV(NDAT),PRNT(ITWO)
      COMMON /FOR_MPI/ ISTATUS(MPI_STATUS_SIZE)
      LTEST=.FALSE.
C
      CALL MPI_INIT(IERR)
      CALL MPI_COMM_RANK(MPI_COMM_WORLD,MY_ID,IERR)
      CALL MPI_COMM_SIZE(MPI_COMM_WORLD,N_PROC,IERR)
      IF(MY_ID.EQ.0) WRITE(IUO,'(/," DSENDB: N_PROC,NDAT =",2I9)') 
     &                                       N_PROC,NDAT
      IF(N_PROC.NE.2) THEN
        IF(MY_ID.EQ.0) WRITE(IUO,'(/,"N_PROC=2 REQUIRED!")')
        IF(MY_ID.EQ.0) WRITE(IUO,'(/,"DSENDB STOP.")')
        CALL MPI_FINALIZE(IERR)
      STOP
      ENDIF
C
      DO IDAT=1,NDAT ! Integers put into SEND:
        SEND(IDAT)=(IDAT+MY_ID)*ONE
      ENDDO
      PRNT(1)=SEND(1)
      PRNT(2)=SEND(NDAT)
      ITAG=1
      IF(MY_ID.EQ.0) WRITE(IUO,'(/,3X,"MY_ID   PRNT(1)",8X,"PRNT(2)")') 
      CALL WRITE_MPI_D04(PRNT,RECV,ITWO,IUO,ITAG) ! Before S/R.
      ISND=MOD(MY_ID+1,N_PROC)
      IRCV=ISND
      ITAG=2
      CALL MPI_BUFFER_ATTACH(BUFFER,NDAT,IERR)
      CALL MPI_BSEND(SEND,NDAT,MPI_DOUBLE_PRECISION,ISND,ITAG,
     &  MPI_COMM_WORLD,IERR)         ! Send to other process.
      CALL MPI_RECV(RECV,NDAT,MPI_DOUBLE_PRECISION,IRCV,ITAG,
     &  MPI_COMM_WORLD,ISTATUS,IERR) ! Receive from other process
      IF(MY_ID.EQ.0) WRITE(IUO,'(/," After send/receive:")') 
      PRNT(1)=RECV(1)
      PRNT(2)=RECV(NDAT)
      CALL WRITE_MPI_D04(PRNT,RECV,ITWO,IUO,ITAG) ! After S/R.
      IF(MY_ID.EQ.0) WRITE(IUO,'(/," DSENDB: ALL DONE.",/)') 
C
      CALL MPI_FINALIZE(IERR)
      STOP
      END

      include 'write_mpi_d04.f'
