      PROGRAM ISEND ! Bernd Berg Apr 11 2008.
C Problem encountered with Standard MPI_SEND and MPI_RECEIVE (S/R) of 
C integer arrays using two MPI processes. Printout to verify correct S/R.
      implicit real*8 (a-h,o-z)
      implicit logical (l)
      include 'mpif.h'
      PARAMETER(IUO=6,ITWO=2,NDAT=1006) ! Set array dimensions.
c     PARAMETER(IUO=6,ITWO=2,NDAT=1007) ! Fails with OPEN MPI.
      DIMENSION NSEND(NDAT),NRECV(NDAT),NPRNT(ITWO)
      COMMON /FOR_MPI/ ISTATUS(MPI_STATUS_SIZE)
      LTEST=.FALSE.
C
      CALL MPI_INIT(IERR)
      CALL MPI_COMM_RANK(MPI_COMM_WORLD,MY_ID,IERR)
      CALL MPI_COMM_SIZE(MPI_COMM_WORLD,N_PROC,IERR)
      IF(MY_ID.EQ.0) WRITE(IUO,'(/," ISEND: N_PROC,NDAT =",2I9)') 
     &                                      N_PROC,NDAT
      IF(N_PROC.NE.2) THEN
        IF(MY_ID.EQ.0) WRITE(IUO,'(/,"N_PROC=2 REQUIRED!")')
        IF(MY_ID.EQ.0) WRITE(IUO,'(/,"ISEND STOP.")')
        CALL MPI_FINALIZE(IERR)
      STOP
      ENDIF
C
      DO IDAT=1,NDAT ! Integers put into NSEND:
        NSEND(IDAT)=IDAT+MY_ID
      ENDDO
      NPRNT(1)=NSEND(1)
      NPRNT(2)=NSEND(NDAT)
      ITAG=1
      IF(MY_ID.EQ.0) WRITE(IUO,'(/,3X,"MY_ID NPRNT(1) NPRNT(2)")') 
      CALL WRITE_MPI_I10(NPRNT,NRECV,ITWO,IUO,ITAG) ! Before S/R.
      ISND=MOD(MY_ID+1,N_PROC)
      IRCV=ISND
      ITAG=2
      CALL MPI_SEND(NSEND,NDAT,MPI_INTEGER,ISND,ITAG,
     &  MPI_COMM_WORLD,IERR)         ! Send to other process.
      CALL MPI_RECV(NRECV,NDAT,MPI_INTEGER,IRCV,ITAG,
     &  MPI_COMM_WORLD,ISTATUS,IERR) ! Receive from other process
      IF(MY_ID.EQ.0) WRITE(IUO,'(/," After send/receive:")') 
      NPRNT(1)=NRECV(1)
      NPRNT(2)=NRECV(NDAT)
      CALL WRITE_MPI_I10(NPRNT,NRECV,ITWO,IUO,ITAG) ! After S/R.
      IF(MY_ID.EQ.0) WRITE(IUO,'(/," ISEND: ALL DONE.",/)') 
C
      CALL MPI_FINALIZE(IERR)
      STOP
      END

      include 'write_mpi_i10.f'
