      SUBROUTINE WRITE_MPI_I08(NSEND,NRECV,NSR,IUO,ITAG) 
C Bernd Berg Nov 12 2007. Prints up to 8 integers in a desired order.
C Uses MPI_ISEND, MPI_IRECEIVE with a REQUEST values and MPI WAIT.
      implicit real*8 (a-h,o-z)
      implicit logical (l)
      PARAMETER(NPROC=2,IZERO=0,ZERO=0.D00,HALF=0.5D00,ONE=1.D00)
      INCLUDE 'mpif.h'
      DIMENSION NSEND(NSR),NRECV(NSR)
      COMMON /FOR_MPI/ ISTATUS(MPI_STATUS_SIZE),NREQ(NPROC)
      IF(NSR.GT.8.OR.IZERO.NE.0) THEN
        CALL MPI_FINALIZE(IERR)
      STOP "WRITE_MPI_I: NSR.GT.8.OR.IZERO.NE.0"
      ENDIF
      CALL MPI_COMM_RANK(MPI_COMM_WORLD,MY_ID,IERR)
      CALL MPI_COMM_SIZE(MPI_COMM_WORLD,N_PROC,IERR)
      IF(N_PROC.NE.NPROC) THEN
        CALL MPI_FINALIZE(IERR)
      STOP "WRITE_MPI_I: Preset NPROC.NE.N_PROC."
      ENDIF
      IF(MY_ID.EQ.0) WRITE(IUO,'(/,I8,8I9)') IZERO,NSEND
      DO I=1,(N_PROC-1)
        IF(MY_ID.EQ.I) CALL MPI_ISEND(NSEND,NSR,MPI_INTEGER,IZERO,ITAG,
     &                                 MPI_COMM_WORLD,NREQ(MY_ID),IERR)
        IF(MY_ID.EQ.0) THEN 
           CALL MPI_IRECV(NRECV,NSR,MPI_INTEGER,I,ITAG,
     &                 MPI_COMM_WORLD,NREQ(MY_ID),IERR)
           CALL MPI_WAIT(NREQ(MY_ID),ISTATUS,IERR)
           WRITE(IUO,'(I8,8I9)') I,NRECV
        END IF
      END DO
      RETURN
      END
